// CHANGED 2004-07-28 Lutz Rogowski
#include <stdio.h>
#include <assert.h>
#include <unistd.h>
#include "audiobuffer.h"
#include "dspout.h"
#include "dspoutrtp.h"
#include "dspaudioout.h"

#include <qapplication.h>
DspAudioOut::DspAudioOut( DspOut *in, DspOut *out )
	: DspAudio( in, out )
{
	curpos = 0;
}

DspAudioOut::~DspAudioOut( void )
{
}

void DspAudioOut::timerTick( void )
{
	if( broken ){
		printf("(b)");
		fflush(stdout);
		return;
	}

	short *curbuf;
	unsigned int outputsize = output->getBuffer().getSize() / sizeof( short );

	if ( !broken ) {
		int numBytes;
		if( input->getDeviceState() == DspOut::DeviceClosed ) {
			return;
		}
        if ( ! input->readableBytes() )
            return;
#if 0
		unsigned int samplesleft = input->getBuffer().getSize() / sizeof( short );
		short *inbuf = (short *)input->getBuffer().getData();

		if (numBytes > 0) {
			input->readBuffer( numBytes );
		} else
		if (!numBytes) {
			if (!currentTone && !newTone) {
				return;
			}
			samplesleft = 80;
			dtmfSamples += samplesleft;
		} else if (dtmfSamples > 0) {
			if (dtmfSamples - samplesleft > 0) {
				dtmfSamples -= 80;
				return;
			} else {
				inbuf += dtmfSamples;
				samplesleft -= dtmfSamples;
				dtmfSamples = 0;
			}
		}
#endif 

//		printf( "[%s->%s] read a buffer, size %d, samples left %d\n",
//			input->getDeviceName().ascii(),
//			output->getDeviceName().ascii(),
//			input->getBuffer().getSize(),
//			samplesleft );

        input->readBuffer( numBytes );
        //qDebug("writing %d ",  input->getBuffer().getSize());
        output->getBuffer().resize( input->getBuffer().getSize() );
		if (!generateDTMF((short*)output->getBuffer().getData(),
			input->getBuffer().getSize() / sizeof(short))) {

			// Copy the data
          
			memcpy( output->getBuffer().getData(),
				input->getBuffer().getData(),
				input->getBuffer().getSize() );
        }

		// If the write fails, mark the pipe as broken and stop sending!
		if( !output->writeBuffer() ) {
            broken = true;
			printf( "DspAudioOut: Broken pipe\n" );
        }




#if 0
		unsigned int samplesleft = input->getBuffer().getSize() / sizeof( short );
		short *inbuf = (short *)input->getBuffer().getData();


		while( samplesleft > 0 ) {
			if( isCanceled() ) break;
			if( samplesleft >= ( outputsize - curpos ) ) {
				curbuf = (short *) copybuffer.getData();
				curbuf += curpos;
				if (!generateDTMF(curbuf, outputsize - curpos)) {
					memcpy( curbuf, inbuf, ( outputsize - curpos ) * sizeof( short ) );
				}
				memcpy( output->getBuffer().getData(), copybuffer.getData(),
					output->getBuffer().getSize() );


//				printf( "[%s->%s] writing buffer, output size %d, copy buffer size %d, cwriteBufferurpos was %d\n",
//					input->getDeviceName().ascii(),
//					output->getDeviceName().ascii(),
//					output->getBuffer().getSize(),
//					copybuffer.getSize(),
//					curpos );

				// If the write fails, mark the pipe as broken and stop sending!
				if( !output->writeBuffer() ) {
					printf( "DspAudio: Broken pipe\n" );
					broken = true;
				}
				samplesleft -= ( outputsize - curpos );
				inbuf += ( outputsize - curpos );
				curpos = 0;

			} else {

//				printf( "[%s->%s] filling in %d samples\n",
//					input->getDeviceName().ascii(),
//					output->getDeviceName().ascii(),
//					samplesleft );

				curbuf = (short *) copybuffer.getData();
				curbuf += curpos;
				if (!generateDTMF(curbuf, samplesleft)) {
					memcpy( curbuf, inbuf, samplesleft * sizeof( short ) );
				}
				curpos += samplesleft;
				samplesleft = 0;
			}
		}
#endif 
	}
}


#ifndef HAVE_THREAD
void DspAudioOut::start( void )
{

	timer = new QTimer();
	connect( timer, SIGNAL( timeout() ), this, SLOT( timeout() ) );
	timer->start( 1 );
}

void DspAudioOut::timeout()
{
	timerTick();
}

#endif


#include "dspaudioout.moc"
