#ifndef DIALLIST_H
#define DIALLIST_H

#include <qvaluelist.h>

class QString;
class QStringList;
class QDate;
class QTime;
class QDomElement;
class QDomDocument;
class SipCall;

struct Call;


class DialList
{
    public:    
        DialList( unsigned int ml );
        ~DialList();
        
        Call* getCall(unsigned int callIndex);
        void insertCall(SipCall *ncall, int type, QString dialNr);
        void delList();
        QString getCallId(unsigned int callIndex);
        QStringList getLastCallsAsString();
        QValueList<Call> getLastCalls();
        QValueList<Call> getAllCalls(unsigned int length=0);
            
    protected:
        void openList();
        void loadCall(QDomElement *c);
        void reInsertCall(QString callId, QString callerNr, QString callerName, QString subject, int type, QDate date, QTime time, int duration);
        bool saveList();
        void saveCall(Call *tmpcall, QDomDocument *doc, QDomElement *parent);

        QString dialListFilename;
        QValueList<Call> lastcalls; //List for last maxlength calls
        QValueList<Call> calls;     //List for all calls
        unsigned int maxlength;
};


#endif
