
#include "kcallgui.h"
#include <kuniqueapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char description[] =
    I18N_NOOP("A KDE Telephony Application");

static const char version[] = "0.5.1";

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "URLs to open" ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("kcall", I18N_NOOP("KCall"), version, description,
                     KAboutData::License_LGPL, "(C) 2005 The KCall Team", 0, 0, "kcall@basyskom.de");
    about.addAuthor( "Mike Hauth", 0, "mike@mike-hauth.de" );
    about.addAuthor( "Eva Brucherseifer", 0, "eva.brucherseifer@basyskom.de" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KUniqueApplication::addCmdLineOptions();

    if ( !KUniqueApplication::start() )
       exit( 0 );

    KUniqueApplication app;

    // see if we are starting with session management
    if (app.isRestored())
    {
        RESTORE(KCallGui);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        if ( args->count() == 0 )
        {
        KCallGui *widget = new KCallGui;
        widget->show();
        }
        else
        {
            int i = 0;
            for (; i < args->count(); i++ )
            {
                KCallGui *widget = new KCallGui;
                widget->show();
                widget->load( args->url( i ) );
            }
        }
        args->clear();
    }

    return app.exec();
}
